import { JSXElementConstructor, ReactHTML, ReactNode } from 'react';
export type TOnClickItem<Props> = (item: Props, index: number, ...props: any[]) => void;
export interface MapProps<Data, AlwaysProps, WithIndex, PropsIn> {
    data?: Data[];
    item: Item<Data, AlwaysProps, WithIndex, PropsIn>;
    keyName?: keyof Data;
    props?: AlwaysProps;
    withIndex?: WithIndex;
    wrapType?: keyof ReactHTML;
    className?: string;
    propsIn?: PropsIn;
}
type Item<Data, AlwaysProps, WithIndex, PropsIn> = (props: PropsIn extends string ? Record<PropsIn, Data> & {
    props: Record<keyof AlwaysProps, AlwaysProps>;
} & (WithIndex extends true ? {
    index: number;
} : {}) : // else
Data & AlwaysProps & (WithIndex extends true ? {
    index: number;
} : {})) => ReactNode;
export type HocProps = <Props extends Obj, AlwaysProps extends Obj, TWithIndex extends boolean | undefined = false, TPropIn extends string | undefined = undefined>(hoc: (comp: any) => any) => JSXElementConstructor<MapProps<Props, AlwaysProps, TWithIndex, TPropIn>>;
export interface WrapProps {
    type?: keyof ReactHTML;
    className?: string;
}
export type Obj = object;
export type EmptyObject = {
    [K in any]: never;
};
export type WithProps<TKey extends string, TData, TProps extends object = object> = Record<TKey, TData> & {
    index?: number;
    onClick?: (item: any) => void;
    props: TProps;
};
export {};
